//-----------------------------------------------------------------------
// 　時限爆弾  for ROBOT ENGINEERS TRAINING SEMINAR
// 　　　　　　　　　　START…カウントダウン開始
//-----------------------------------------------------------------------
// Copyright (C) 2018  Takao Satoh
//-----------------------------------------------------------------------

#define NOTE_P   0
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637

//ライブラリを取り込む
//#include <Tone.h>
#include <TM1617.h>
#include <Switch.h>
#define START st.isPressed()
#define ON true
#define OFF false
#define SPK A2
#define CLK 13
#define DIO 11
#define STB 2
Button st = Button(8,BUTTON_PULLUP);
TM1617 tm1617(CLK, DIO, STB);


//楽譜データ
//char *song="smbdeath:d=4,o=4,b=500:16c5,16c#5,8d.5,4p,2p,4b4,4f5,4p,4f5,4f5,4e5,4d5,4c5,4e4,4p,4e4,4c4,4p,2p";
uint16_t Note[] = {
//   c5,     c#5,     d5,     p,     p,     b4,     f5,     p,     f5,
NOTE_C5,NOTE_CS5,NOTE_D5,NOTE_P,NOTE_P,NOTE_B4,NOTE_F5,NOTE_P,NOTE_F5,
//   f5,     e5,     d5,     c5,     e4,     p,     e4,     c4,     p,     p
NOTE_F5,NOTE_E5,NOTE_D5,NOTE_C5,NOTE_E4,NOTE_P,NOTE_E4,NOTE_C4,NOTE_P,NOTE_P
};
uint8_t Dura[] = {
//16,16,8., 4, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2
   1, 1, 3, 4, 8, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 8
};

//Tone tone1;
int i, f1 = 2252, f2 = 2000;

void play_end(void)
{
  int note, dura, beat = 32;

  for(i=0;i<19;i++) {
    note = Note[i];
    dura = Dura[i] * beat;
    if(note)
      tone(SPK,note,dura);
    delay(dura);
  }
}

void setup(void)
{
  tm1617.brightness(3); //マトリクスの明るさを３にする（０−８）
  tm1617.clearDisplay();
  while(!START == ON)  delay(100);
  tm1617.displayNum(i);//マトリクスに二桁数字表示をおこなう  
  //tone1.begin(SPK);
}

void loop(void)
{
  for(i=10;i>0;i--) {
    tm1617.displayNum(i);//マトリクスに二桁数字表示をおこなう
    tone(SPK,f1,50);
    delay(1000);
    tm1617.displayNum(--i);//マトリクスに二桁数字表示をおこなう
    tone(SPK,f2,50);
    delay(1000);
  }

  tm1617.displayNum(0);//マトリクスに二桁数字表示をおこなう
  for(i=0;i<30;i++) {
    tone(SPK,f1,50);
    tm1617.brightness(7);
    delay(50);
    //tm1617.clearDisplay();
    tm1617.brightness(-1);
    delay(50);
  }

  for(int i=1;i<3000;i++) {//爆発を作る
    tone(SPK,random(50,600),10);
    delayMicroseconds(100);
  }
  delay(50);
  //noTone(SPK);//音を止める
  //tone1.play_rtttl(song);//音楽を再生する
  play_end();
  while(1);
}

